VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIPropertyStore"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 09/2018

' Komplett mit ein paar zustzlichen Funktionen

Option Explicit

Private Const ERR_BASE As Long = 40670
Private Const CLSID_PropertyStore As String = ""

Private Const IID_IPropertyStore As String = "{886D8EEB-8CF2-4446-8D02-CDBA1DBDCF99}"

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetCount
    vtb_GetAt
    vtb_GetValue
    vtb_SetValue
    vtb_Commit
End Enum

' ----==== Propsys API-Deklarationen ====----
Private Declare Function VariantToPropVariant Lib "propsys.dll" (ByRef pVar As Variant, ByRef ppropvar As PROPVARIANT) As Long

Private Declare Function PropVariantToBoolean Lib "propsys.dll" (ByRef ppropvar As PROPVARIANT, ByRef pfRet As Boolean) As Long
                         
Private Declare Function PropVariantToFileTime Lib "propsys.dll" (ByRef ppropvar As PROPVARIANT, ByVal pstfOut As PSTIME_FLAGS, _
                                                                                                 ByRef pftOut As FILETIME) As Long

Private Declare Function PropVariantChangeType Lib "propsys.dll" (ByVal ppropvarDest As Long, ByVal propvarSrc As Long, _
                                                                  ByVal flags As Long, ByVal vt As VARENUM) As Long

Private m_initialized As Boolean
Private m_Interface As Interface_Data

Public Function GetCount() As Long

    Dim lRet As Long
    Dim cProps As Long
    Dim pcProps As Long

    pcProps = VarPtr(cProps)

    If x_OleInvoke(vtb_GetCount, pcProps) Then
        lRet = cProps
    End If

    GetCount = lRet

End Function

Friend Function GetAt(ByVal iProp As Long) As PROPERTYKEY

    Dim tRet As PROPERTYKEY
    Dim tPROPERTYKEY As PROPERTYKEY
    Dim ptPROPERTYKEY As Long

    ptPROPERTYKEY = VarPtr(tPROPERTYKEY)

    If x_OleInvoke(vtb_GetAt, iProp, ptPROPERTYKEY) Then
        tRet = tPROPERTYKEY
    End If

    GetAt = tRet

End Function

Friend Function GetValue(ByRef key As PROPERTYKEY) As PROPVARIANT

    Dim tRet As PROPVARIANT
    Dim pkey As Long
    Dim tPROPVARIANT As PROPVARIANT
    Dim ptPROPVARIANT As Long

    pkey = VarPtr(key)
    ptPROPVARIANT = VarPtr(tPROPVARIANT)

    If x_OleInvoke(vtb_GetValue, pkey, ptPROPVARIANT) Then
        tRet = tPROPVARIANT
    End If

    GetValue = tRet

End Function

Friend Function SetValue(ByRef key As PROPERTYKEY, ByRef propvar As PROPVARIANT) As Boolean
    
    Dim bRet As Boolean
    Dim pkey As Long
    Dim ppropvar As Long
    
    pkey = VarPtr(key)
    ppropvar = VarPtr(propvar)
    
    If x_OleInvoke(vtb_SetValue, pkey, ppropvar) Then
        bRet = True
    End If

    SetValue = bRet

End Function

Public Function Commit() As Boolean

    Dim bRet As Boolean
    
    If x_OleInvoke(vtb_Commit) Then
        bRet = True
    End If

    Commit = bRet

End Function

Public Sub RaiseError(Optional ByVal Raise As Boolean = True)

    m_Interface.RaiseErrors = Raise

End Sub

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True
    m_Interface.ifc = pInterface
    m_initialized = True

End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then
        InterfaceError m_Interface, ecd_OleInvoke
    Else
        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)
    End If

End Function

Public Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & ".clsIPropertyStore", .etx

        .ecd = 0
        .etx = vbNullString

    End With

End Sub

' ab hier die zustzliche Funktionen

Friend Function GetValueStr(ByRef key As PROPERTYKEY) As String

    Dim sRet As String
    Dim iRet As Integer
    Dim lRet As Long
    Dim cRet As Currency
    Dim bRet As Boolean
    Dim vRet As Variant
    Dim lItem As Long
    Dim lCount As Long
    Dim pPtr As Long
    Dim pkey As Long
    Dim ptPROPVARIANT As Long
    Dim tFILETIME As FILETIME
    Dim tPROPVARIANT As PROPVARIANT
    
    pkey = VarPtr(key)
    ptPROPVARIANT = VarPtr(tPROPVARIANT)
    sRet = vbNullString
    
    If x_OleInvoke(vtb_GetValue, pkey, ptPROPVARIANT) Then
    
        Select Case tPROPVARIANT.vt
        
        Case VARENUM.VT_EMPTY
            sRet = vbNullString
            
        Case VARENUM.VT_BOOL, VARENUM.VT_BSTR, VARENUM.VT_LPWSTR, _
             VARENUM.VT_I2, VARENUM.VT_UI2, VARENUM.VT_I4, _
             VARENUM.VT_UI4, VARENUM.VT_I8, VARENUM.VT_UI8, VARENUM.VT_CLSID
            
            pPtr = VarPtr(vRet)
            ptPROPVARIANT = VarPtr(tPROPVARIANT)

            If PropVariantChangeType(pPtr, ptPROPVARIANT, 0&, VT_BSTR) = S_OK Then
            
                sRet = CStr(vRet)
                
            End If
            
        Case VARENUM.VT_FILETIME

            If PropVariantToFileTime(tPROPVARIANT, PSTF_LOCAL, tFILETIME) = S_OK Then

                sRet = StringFromFileTime(tFILETIME)

            End If
            
        Case VARENUM.VT_VECTOR Or VARENUM.VT_LPWSTR
            
            pPtr = VarPtr(vRet)
            ptPROPVARIANT = VarPtr(tPROPVARIANT)
            
            If PropVariantChangeType(pPtr, ptPROPVARIANT, 0&, VT_ARRAY Or VT_BSTR) = S_OK Then
                
                lCount = UBound(vRet)
                
                For lItem = 0 To lCount
                
                    If lItem > 0 Then
                    
                        sRet = sRet & ";"
                        
                    End If
                    
                    sRet = sRet & vRet(lItem)
                    
                Next
                
            End If
            
        Case VARENUM.VT_STREAM
            sRet = "{Picture Stream}"
            
        Case Else
            sRet = "[Unknown]"
            
        End Select
        
    End If
    
    GetValueStr = sRet
    
End Function

Friend Function GetValueBool(ByRef key As PROPERTYKEY) As Boolean

    Dim bRet As Boolean
    Dim bTmp As Boolean
    Dim pkey As Long
    Dim ptPROPVARIANT As Long
    Dim tPROPVARIANT As PROPVARIANT

    pkey = VarPtr(key)
    ptPROPVARIANT = VarPtr(tPROPVARIANT)

    If x_OleInvoke(vtb_GetValue, pkey, ptPROPVARIANT) Then

        If PropVariantToBoolean(tPROPVARIANT, bTmp) = S_OK Then
            bRet = bTmp
        End If
    End If

    GetValueBool = bRet

End Function

Friend Function SetValueBool(ByRef key As PROPERTYKEY, ByVal Value As Boolean) As Boolean

    Dim bRet As Boolean
    Dim pkey As Long
    Dim vValue As Variant
    Dim pvValue As Long
    Dim ptPROPVARIANT As Long
    Dim tPROPVARIANT As PROPVARIANT

    vValue = Value
    pvValue = VarPtr(vValue)
    ptPROPVARIANT = VarPtr(tPROPVARIANT)
    
    If PropVariantChangeType(ptPROPVARIANT, pvValue, 0&, VT_BOOL) = S_OK Then

        pkey = VarPtr(key)
        ptPROPVARIANT = VarPtr(tPROPVARIANT)

        If x_OleInvoke(vtb_SetValue, pkey, ptPROPVARIANT) Then
            If x_OleInvoke(vtb_Commit) Then
                bRet = True
            End If

        End If
    
    End If

    SetValueBool = bRet

End Function

Friend Function SetValueUI4(ByRef key As PROPERTYKEY, ByVal Value As Long) As Boolean

    Dim bRet As Boolean
    Dim pkey As Long
    Dim vValue As Variant
    Dim pvValue As Long
    Dim ptPROPVARIANT As Long
    Dim tPROPVARIANT As PROPVARIANT

    vValue = Value
    pvValue = VarPtr(vValue)
    ptPROPVARIANT = VarPtr(tPROPVARIANT)
    
    If PropVariantChangeType(ptPROPVARIANT, pvValue, 0&, VT_UI4) = S_OK Then

        pkey = VarPtr(key)
        ptPROPVARIANT = VarPtr(tPROPVARIANT)

        If x_OleInvoke(vtb_SetValue, pkey, ptPROPVARIANT) Then
            If x_OleInvoke(vtb_Commit) Then
                bRet = True
            End If

        End If
    
    End If

    SetValueUI4 = bRet

End Function

Friend Function SetValueStr(ByRef key As PROPERTYKEY, ByVal Value As String) As Boolean

    Dim bRet As Boolean
    Dim pkey As Long
    Dim vValue As Variant
    Dim pvValue As Long
    Dim ptPROPVARIANT As Long
    Dim tPROPVARIANT As PROPVARIANT

    vValue = Value
    pvValue = VarPtr(vValue)
    ptPROPVARIANT = VarPtr(tPROPVARIANT)
    
    If PropVariantChangeType(ptPROPVARIANT, pvValue, 0&, VT_LPWSTR) = S_OK Then

        pkey = VarPtr(key)
        ptPROPVARIANT = VarPtr(tPROPVARIANT)

        If x_OleInvoke(vtb_SetValue, pkey, ptPROPVARIANT) Then
            If x_OleInvoke(vtb_Commit) Then
                bRet = True
            End If

        End If
    
    End If

    SetValueStr = bRet

End Function

Friend Function SetValueStrArray(ByRef key As PROPERTYKEY, ByVal Value As String) As Boolean

    Dim bRet As Boolean
    Dim pkey As Long
    Dim vValue As Variant
    Dim ptPROPVARIANT As Long
    Dim tPROPVARIANT As PROPVARIANT

    vValue = Split(Value, ";")
    
    If VariantToPropVariant(vValue, tPROPVARIANT) = S_OK Then
        
        pkey = VarPtr(key)
        ptPROPVARIANT = VarPtr(tPROPVARIANT)

        If x_OleInvoke(vtb_SetValue, pkey, ptPROPVARIANT) Then
            If x_OleInvoke(vtb_Commit) Then
                bRet = True
            End If

        End If
    
    End If

    SetValueStrArray = bRet

End Function

Friend Function GetValueStream(ByRef key As PROPERTYKEY) As clsIStream

    Dim lRet As Long
    Dim vRet As Variant
    Dim pkey As Long
    Dim ptPROPVARIANT As Long
    Dim tPROPVARIANT As PROPVARIANT
    Dim IStream As clsIStream

    pkey = VarPtr(key)
    ptPROPVARIANT = VarPtr(tPROPVARIANT)

    If x_OleInvoke(vtb_GetValue, pkey, ptPROPVARIANT) Then
    
        If tPROPVARIANT.vData <> 0 Then
        
            Set IStream = New clsIStream
            Call IStream.Initialize(tPROPVARIANT.vData)
        
        Else
        
            Set IStream = Nothing
            
        End If
        
    End If

    Set GetValueStream = IStream

End Function
'
'Friend Function SetValueStream(ByRef key As PROPERTYKEY, ByVal Value As clsIStream) As Boolean
'
'    Dim bRet As Boolean
'    Dim pkey As Long
'    Dim ptPROPVARIANT As Long
'    Dim tPROPVARIANT As PROPVARIANT
'
'    If Not Value Is Nothing Then
'
'        tPROPVARIANT.vt = VARENUM.VT_STREAM
'        tPROPVARIANT.vData = Value.GetInterfacePtr
'
'        pkey = VarPtr(key)
'        ptPROPVARIANT = VarPtr(tPROPVARIANT)
'
'        If x_OleInvoke(vtb_SetValue, pkey, ptPROPVARIANT) Then
'            If x_OleInvoke(vtb_Commit) Then
'                bRet = True
'            End If
'        End If
'    End If
'
'    SetValueStream = bRet
'
'End Function

Friend Function SetValueStream(ByRef key As PROPERTYKEY, ByVal Value As Long) As Boolean
    Dim bRet As Boolean
    Dim pkey As Long
    Dim ptPROPVARIANT As Long
    Dim tPROPVARIANT As PROPVARIANT
    
    If Value <> 0& Then
    
        tPROPVARIANT.vt = VARENUM.VT_STREAM
        tPROPVARIANT.vData = Value
        
        pkey = VarPtr(key)
        ptPROPVARIANT = VarPtr(tPROPVARIANT)
        
        If x_OleInvoke(vtb_SetValue, pkey, ptPROPVARIANT) Then
            If x_OleInvoke(vtb_Commit) Then
                bRet = True
            End If
        End If
    End If
    
    SetValueStream = bRet
    
End Function


Friend Function DeleteValue(ByRef key As PROPERTYKEY) As Boolean
    
    Dim bRet As Boolean
    Dim pkey As Long
    Dim ptPROPVARIANT As Long
    Dim tPROPVARIANT As PROPVARIANT
    
        tPROPVARIANT.vt = VARENUM.VT_EMPTY
        tPROPVARIANT.vData = 0&
        
        pkey = VarPtr(key)
        ptPROPVARIANT = VarPtr(tPROPVARIANT)
        
        If x_OleInvoke(vtb_SetValue, pkey, ptPROPVARIANT) Then
            If x_OleInvoke(vtb_Commit) Then
                bRet = True
            End If
        End If
    
    DeleteValue = bRet
    
End Function


